#include <string.h>
#include <jni.h>
#include <android/log.h>
#include <pthread.h>

int thr_id;
int end_flag;
pthread_t p_thread[2];

JavaVM *glpVM = NULL;
jclass jObject;
jmethodID funccb;
void Notify(int n);

void *t_function(void *data)
{
    int id;
    int i = 0;
    id = *((int *)data);

    while(end_flag)
    {
        Notify(i);
        i++;
        sleep(1);
    }
}


jint startThread_Native(JNIEnv* env, jobject thiz){
    end_flag = 1;
    int b = 2;

    __android_log_print(ANDROID_LOG_INFO, "NATIVE", "Call start thread");
    
    jclass cls;
    //cls = (*env)->GetObjectClass(env, thiz);
    cls = (*env)->FindClass(env, "net/hybridego/test/NativeThreadActivity");
    if (cls == NULL) {
        __android_log_print(ANDROID_LOG_INFO, "NATIVE", "Can't fine the class.");
    }
    
    jObject = (jclass)(*env)->NewGlobalRef(env, cls);
    funccb = (*env)->GetStaticMethodID(env, cls,"callback", "(I)V");
    if (funccb == 0 ) {
        __android_log_print(ANDROID_LOG_INFO, "NATIVE", "Can't fine the function.");
        (*env)->DeleteGlobalRef(env, jObject);
    }
    else {
        __android_log_print(ANDROID_LOG_INFO, "NATIVE", "Method connect success ..............\n");
        (*env)->CallStaticVoidMethod(env, cls, funccb, 10);
    }

    // 쓰레드 생성 아규먼트로 2 를 넘긴다. 
    thr_id = pthread_create(&p_thread[1], NULL, t_function, (void *)&b);
    if (thr_id < 0)
    {
        __android_log_print(ANDROID_LOG_INFO, "NATIVE", "Create thread fail.\n");
        return -1;
    }
    return 0;
}

jint endThread_Native(JNIEnv* env, jobject thiz){
    __android_log_print(ANDROID_LOG_INFO, "NATIVE", "Call end thread");
    end_flag = 0;
    return 0;
}





void Notify(int n) {
        int value=0;
        value = n;
        if(!glpVM){
                __android_log_print(ANDROID_LOG_INFO, "NATIVE", "error (!glpVM)");
                return;
        }
        
        if(!funccb){
                __android_log_print(ANDROID_LOG_INFO, "NATIVE", "error (!funccb)");
                return;
        }
        JNIEnv *env = NULL;
        (*glpVM)->AttachCurrentThread(glpVM, &env, NULL);
        if(env == NULL || jObject == NULL){
                (*glpVM)->DetachCurrentThread(glpVM);
                __android_log_print(ANDROID_LOG_INFO, "NATIVE", "error (env == NULL || AVM_JM.jObject == NULL)");
                return;
        }
        (*env)->CallStaticVoidMethod(env, jObject, funccb, value);
        (*glpVM)->DetachCurrentThread(glpVM);
}


static JNINativeMethod methods[] = {
        {"startThread", "()I", (void*)startThread_Native },
        {"endThread", "()I", (void*)endThread_Native },
};


jint JNI_OnLoad(JavaVM* vm, void* reserved)
{
    jint result = -1;
    JNIEnv* env = NULL;
    jclass cls;

    if ((*vm)->GetEnv(vm, (void**)&env, JNI_VERSION_1_4) != JNI_OK) {
        __android_log_print(ANDROID_LOG_INFO, "NATIVE", "GetEnv failed.\n");
        goto error;
    }
    
    cls = (*env)->FindClass(env, "net/hybridego/test/NativeThreadActivity");
    if (cls == NULL) {
        __android_log_print(ANDROID_LOG_INFO, "NATIVE", "Native registration unable to find class(AVMJni)");
        goto error;
    }
    
    if ((*env)->RegisterNatives(env, cls, methods, sizeof(methods)/sizeof(methods[0])) < 0) {
        __android_log_print(ANDROID_LOG_INFO, "NATIVE", "RegisterNatives failed !!!\n");
        goto error;
    }

    result = JNI_VERSION_1_4;
    glpVM = vm;
error:
    return result;
}

